import dotProp from "dot-prop-immutable";

var UPDATE_INPUT_VALUE = 'UPDATE_INPUT_VALUE';

export var changeField = function changeField(type, name, value) {
    return {
        type: type,
        name: name,
        value: value
    };
};

export var createBoundType = function createBoundType(namespace) {
    return UPDATE_INPUT_VALUE + '.' + namespace;
};

export default (function (namespace, defaultState) {
    return function () {
        var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState || {};
        var action = arguments[1];

        var boundType = createBoundType(namespace);
        switch (action.type) {
            case boundType:
                var fieldPathWithoutNamespace = action.name.replace(namespace + '.', '');
                return dotProp.set(state, fieldPathWithoutNamespace, action.value);

            default:
                return state;
        }
    };
});