'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.createBoundType = exports.changeField = undefined;

var _dotPropImmutable = require('dot-prop-immutable');

var _dotPropImmutable2 = _interopRequireDefault(_dotPropImmutable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var UPDATE_INPUT_VALUE = 'UPDATE_INPUT_VALUE';

var changeField = exports.changeField = function changeField(type, name, value) {
    return {
        type: type,
        name: name,
        value: value
    };
};

var createBoundType = exports.createBoundType = function createBoundType(namespace) {
    return UPDATE_INPUT_VALUE + '.' + namespace;
};

exports.default = function (namespace, defaultState) {
    return function () {
        var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultState || {};
        var action = arguments[1];

        var boundType = createBoundType(namespace);
        switch (action.type) {
            case boundType:
                var fieldPathWithoutNamespace = action.name.replace(namespace + '.', '');
                return _dotPropImmutable2.default.set(state, fieldPathWithoutNamespace, action.value);

            default:
                return state;
        }
    };
};